#clear the memory
rm(list=ls())

#load the package rmr2
library(rmr2)

#in order to work without the Hadoop environment
rmr.options(backend="local")

#vector of integer values
x <- c(2,6,67,85,7,9,4,21,78,45)

#map function
map_valeurs <- function(., v){
  #print
  print("map") ; print(v)
  #calculate the key
  cle <- ifelse (v %% 2 == 0, 1, 2)
  #return the key and the vector v
  return(keyval(cle,v))
}

#reduce function
reduce_valeurs <- function(k, v){
  #print
  print("reduce") ; print(k) ; print(v)
  #length of the vector
  nb <- length(v)
  #return the key and the corresponding value (result)
  return(keyval(k, nb))
}

#transform the data in a type recognized by rmr2
x.dfs <- to.dfs(x)

#mapreduce of rmr2
calcul <- mapreduce(input = x.dfs, map = map_valeurs, reduce = reduce_valeurs)

#transform the result in a type recognized by R
resultat <- from.dfs(calcul)

#print the result
print(resultat)

#class of resultat
print(class(resultat))

#print the keys
print(keys(resultat))

#print the result values
print(values(resultat))

