#clear the memory
rm(list=ls())

#package rmr2
library(rmr2)

#local backend
rmr.options(backend="local")

#group membership of the individuals
y <- factor(c(1,1,2,1,2,3,1,2,3,2,1,1,2,3,3))

#values of the response variable
x <- c(0.2,0.65,0.8,0.7,0.85,0.78,1.6,0.7,1.2,1.1,0.4,0.7,0.6,1.7,0.15)

#create a data frame from y and x
don <- data.frame(cbind(y,x))

#map
map_ssq <- function(., v){
  #the column y is the key
  cle <- v$y
  #return key and the entire data frame
  return(keyval(cle,v))
}

#reduce
reduce_ssq <- function(k,v){
  #print
  print("reduce") ; print(v)
  #counting the number of row of the data frame
  n <- nrow(v)
  #calculate the sum of squares using the column 'x' of data.frame
  ssq <- (n-1) * var(v$x)
  #return key and result of calculation
  return(keyval(k,ssq))
}

#format rmr2
don.dfs <- to.dfs(don)

#mapreduce
calcul <- mapreduce(input=don.dfs,map=map_ssq,reduce=reduce_ssq)

#retrieve the result
resultat <- from.dfs(calcul)
print(resultat)

#SSR
ssr <- sum(resultat$val)
print(ssr)

#checking
print(aov(x ~ y))

